// Matrix Construct
//
// Copyright (C) Matrix Construct Developers, Authors & Contributors
// Copyright (C) 2016-2018 Jason Volk <jason@zemos.net>
//
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice is present in all copies. The
// full license for this software is available in the LICENSE file.

constexpr const char *const ircd::m::name::auth_events;
constexpr const char *const ircd::m::name::content;
constexpr const char *const ircd::m::name::depth;
constexpr const char *const ircd::m::name::event_id;
constexpr const char *const ircd::m::name::hashes;
constexpr const char *const ircd::m::name::membership;
constexpr const char *const ircd::m::name::origin;
constexpr const char *const ircd::m::name::origin_server_ts;
constexpr const char *const ircd::m::name::prev_events;
constexpr const char *const ircd::m::name::prev_state;
constexpr const char *const ircd::m::name::redacts;
constexpr const char *const ircd::m::name::room_id;
constexpr const char *const ircd::m::name::sender;
constexpr const char *const ircd::m::name::signatures;
constexpr const char *const ircd::m::name::state_key;
constexpr const char *const ircd::m::name::type;
constexpr const char *const ircd::m::name::unsigned_;

constexpr const char *const ircd::m::name::edus;
constexpr const char *const ircd::m::name::pdu_failures;
constexpr const char *const ircd::m::name::pdus;

constexpr const char *const ircd::m::name::destination;
constexpr const char *const ircd::m::name::method;
constexpr const char *const ircd::m::name::uri;

constexpr const char *const ircd::m::name::old_verify_keys;
constexpr const char *const ircd::m::name::server_name;
constexpr const char *const ircd::m::name::tls_fingerprints;
constexpr const char *const ircd::m::name::valid_until_ts;
constexpr const char *const ircd::m::name::verify_keys;

constexpr const char *const ircd::m::name::m_room_aliases;
constexpr const char *const ircd::m::name::m_room_canonical_alias;
constexpr const char *const ircd::m::name::m_room_create;
constexpr const char *const ircd::m::name::m_room_join_rules;
constexpr const char *const ircd::m::name::m_room_member;
constexpr const char *const ircd::m::name::m_room_power_levels;
constexpr const char *const ircd::m::name::m_room_message;
constexpr const char *const ircd::m::name::m_room_name;
constexpr const char *const ircd::m::name::m_room_topic;
constexpr const char *const ircd::m::name::m_room_avatar;
constexpr const char *const ircd::m::name::m_room_pinned_events;
constexpr const char *const ircd::m::name::m_room_history_visibility;
constexpr const char *const ircd::m::name::m_room_third_party_invite;
constexpr const char *const ircd::m::name::m_room_guest_access;

constexpr const char *const ircd::m::name::event_fields;
constexpr const char *const ircd::m::name::event_format;
constexpr const char *const ircd::m::name::account_data;
constexpr const char *const ircd::m::name::presence;
constexpr const char *const ircd::m::name::room;
constexpr const char *const ircd::m::name::timeline;
constexpr const char *const ircd::m::name::ephemeral;
constexpr const char *const ircd::m::name::state;
constexpr const char *const ircd::m::name::rooms;
constexpr const char *const ircd::m::name::not_rooms;
constexpr const char *const ircd::m::name::include_leave;
constexpr const char *const ircd::m::name::types;
constexpr const char *const ircd::m::name::not_types;
constexpr const char *const ircd::m::name::senders;
constexpr const char *const ircd::m::name::not_senders;
constexpr const char *const ircd::m::name::limit;
constexpr const char *const ircd::m::name::contains_url;
constexpr const char *const ircd::m::name::lazy_load_members;
constexpr const char *const ircd::m::name::include_redundant_members;

constexpr const char *const ircd::m::name::edu_type;

constexpr const char *const ircd::m::name::user_id;
constexpr const char *const ircd::m::name::last_active_ago;
constexpr const char *const ircd::m::name::currently_active;
constexpr const char *const ircd::m::name::status_msg;

constexpr const char *const ircd::m::name::ts;
constexpr const char *const ircd::m::name::data;
constexpr const char *const ircd::m::name::event_ids;

constexpr const char *const ircd::m::name::typing;
constexpr const char *const ircd::m::name::timeout;

constexpr const char *const ircd::m::name::user;
constexpr const char *const ircd::m::name::medium;
constexpr const char *const ircd::m::name::address;
constexpr const char *const ircd::m::name::password;
constexpr const char *const ircd::m::name::token;
constexpr const char *const ircd::m::name::device_id;
constexpr const char *const ircd::m::name::initial_device_display_name;
constexpr const char *const ircd::m::name::identifier;

constexpr const char *const ircd::m::name::username;
constexpr const char *const ircd::m::name::bind_email;
constexpr const char *const ircd::m::name::auth;
constexpr const char *const ircd::m::name::inhibit_login;

constexpr const char *const ircd::m::name::visibility;
constexpr const char *const ircd::m::name::room_alias_name;
constexpr const char *const ircd::m::name::name_;
constexpr const char *const ircd::m::name::topic;
constexpr const char *const ircd::m::name::invite;
constexpr const char *const ircd::m::name::invite_3pid;
constexpr const char *const ircd::m::name::creation_content;
constexpr const char *const ircd::m::name::initial_state;
constexpr const char *const ircd::m::name::preset;
constexpr const char *const ircd::m::name::is_direct;
constexpr const char *const ircd::m::name::guest_can_join;
constexpr const char *const ircd::m::name::power_level_content_override;
constexpr const char *const ircd::m::name::parent_room_id;
constexpr const char *const ircd::m::name::creator;
constexpr const char *const ircd::m::name::room_version;

constexpr const char *const ircd::m::name::id_server;

constexpr const char *const ircd::m::name::id;
constexpr const char *const ircd::m::name::url;
constexpr const char *const ircd::m::name::as_token;
constexpr const char *const ircd::m::name::hs_token;
constexpr const char *const ircd::m::name::sender_localpart;
constexpr const char *const ircd::m::name::namespaces;
constexpr const char *const ircd::m::name::rate_limited;
constexpr const char *const ircd::m::name::protocols;

constexpr const char *const ircd::m::name::users;
constexpr const char *const ircd::m::name::aliases;

constexpr const char *const ircd::m::name::exclusive;
constexpr const char *const ircd::m::name::regex;

constexpr const char *const ircd::m::name::display_name;
constexpr const char *const ircd::m::name::last_seen_ip;
constexpr const char *const ircd::m::name::last_seen_ts;
constexpr const char *const ircd::m::name::keys;
constexpr const char *const ircd::m::name::device_display_name;
constexpr const char *const ircd::m::name::algorithms;

constexpr const char *const ircd::m::name::message_id;
constexpr const char *const ircd::m::name::messages;

constexpr const char *const ircd::m::name::stream_id;
constexpr const char *const ircd::m::name::prev_id;
constexpr const char *const ircd::m::name::deleted;
constexpr const char *const ircd::m::name::access_token_id;

constexpr const char *const ircd::m::name::search_term;
constexpr const char *const ircd::m::name::order_by;
constexpr const char *const ircd::m::name::event_context;
constexpr const char *const ircd::m::name::include_state;
constexpr const char *const ircd::m::name::groupings;
constexpr const char *const ircd::m::name::filter;
